package login.page;

/***********************************************************************
 
 * Author: Ismail Alson Ali Rasheed (S2000811)
 * Date Created: 01.12.2021
 * Date Last Modified: 
 *
 *  Class Name: ValidateDetails
 *  Inherits the class: None
 *  Description: Deals with validating the user input into the 
 *               registration window and storing them inside text files.
              
***********************************************************************/

public class ValidateDetails {
    
/*****************************************************************************
 * Function: checkTotalErrors() 
 * Description: Checks if any error is generated by the validation methods for the 
 *              user input data.
    * @param error1 - Checks number of errors for first data validation function 
    * @param fieldName - Stores the content validated without any errors.
    * @param fieldContent - Gets the content from the field which is input by user.
 * @return content of the field if no error is returned from data validation
 *         functions, or else return null.
*****************************************************************************/

    public String checkTotalErrors(Integer error1, String fieldName, String fieldContent){
        
        if (error1 == null){
            return null;
        }
        else {
            fieldName = fieldContent;
            return fieldName;
        }
    }

    
 /***********************************************************************************
 * Function: checkTotalErrors()
 * Description: Checks if any error is generated by the validation methods for the 
 *              user input data.
    * @param error1 - Checks number of errors for first data validation function 
    * @param error2 - Checks number of errors for first data validation function 
    * @param fieldName - Stores the content validated without any errors.
    * @param fieldContent - Gets the content from the field which is input by user.
 * @return content of the field if no error is returned from data validation
 *         functions, or else return null.
************************************************************************************/   
    public String checkTotalErrors(Integer error1, Integer error2, String fieldName, String fieldContent) {
        
        if (error1 == null || error2 == null){
            return null;
        }
        else {
            fieldName = fieldContent;
            return fieldName;
        }
    }

    
 /***********************************************************************************
 * Function: checkTotalErrors()
 * Description: Checks if any error is generated by the validation methods for the 
 *              user input data.
    * @param error1 - Checks number of errors for first data validation function 
    * @param error2 - Checks number of errors for first data validation function 
    * @param error3 - Checks number of errors for first data validation function 
    * @param fieldName - Stores the content validated without any errors.
    * @param fieldContent - Gets the content from the field which is input by user.
 * @return content of the field if no error is returned from data validation
 *         functions, or else return null.
************************************************************************************/
    public String checkTotalErrors(Integer error1, Integer error2, Integer error3, String fieldName, String fieldContent) {
        
        if (error1 == null || error2 == null || error3 == null){
            return null;
        }
        else {
            fieldName = fieldContent;
            return fieldName;
        }
    }    
     
    
 /***********************************************************************************
 * Function: checkTotalErrors()
 * Description: Checks if any error is generated by the validation methods for the 
 *              user input data.
    * @param error1 - Checks number of errors for first data validation function 
    * @param error2 - Checks number of errors for first data validation function 
    * @param fieldName - Stores the content validated without any errors.
    * @param fieldContent - Gets the content from the field which is input by user.
 * @return content of the field if no error is returned from data validation
 *         functions, or else return null.
************************************************************************************/    
    public Double checkTotalErrors(Integer error1, Integer error2, Double fieldName, String fieldContent) {
        
        if (error1 == null || error2 == null){
            return null;
        }
        else {
            fieldName = Double.parseDouble(fieldContent);
            return fieldName;
        }
    }


 /***********************************************************************************
 * Function: checkTotalErrors()
 * Description: Checks if any error is generated by the validation methods for the 
 *              user input data.
    * @param error1 - Checks number of errors for first data validation function 
    * @param error2 - Checks number of errors for first data validation function 
    * @param error3 - Checks number of errors for first data validation function 
    * @param fieldName - Stores the content validated without any errors.
    * @param fieldContent - Gets the content from the field which is input by user.
 * @return content of the field if no error is returned from data validation
 *         functions, or else return null.
************************************************************************************/  
    public Integer checkTotalErrors(Integer error1, Integer error2, Integer error3, Integer fieldName, String fieldContent){
        
        if (error1 == null || error2 == null || error3 == null){
            return null;
        }
        else{
            fieldName = Integer.parseInt(fieldContent);
            return fieldName;
 
        }
    }

     
    
    
    
    
/* ############################################################################### */ 
/* ############################################################################### */   
/* ############################################################################### */   

    
    
    
   
    
 /***********************************************************************************
 * Function: checkFieldEmpty()
 * Description: Checks if field is empty
     * @param fieldEmpty - Checks if field is empty.
     * @param jLabelName - Name of label that displays error message.
 * @return the content of the field after validation is complete without
 *         any errors.
************************************************************************************/  
    
    public Integer checkFieldEmpty(boolean fieldEmpty, javax.swing.JLabel jLabelName)
    {
        if (fieldEmpty == true) {
            jLabelName.setVisible(true);
            return null; 
        }
        else {
            jLabelName.setVisible(false);
            return 0; 
        }
    }  
    
    
    
/***********************************************************************************
 * Function: checkContentsAreLetters()
 * Description: Checks whether the content in the field contains only letters.
     * @param contentLetters - Checks whether content are only letters.
     * @param jLabelName - Name of label that displays error message.
 * @return number of errors: 0 if no error is present, null if error is present.
***********************************************************************************/
    
    public Integer checkContentsAreLetters(boolean contentLetters, javax.swing.JLabel jLabelName)
    {
        if (contentLetters == false){
            jLabelName.setVisible(true);
            return null;
        }
        else {
            jLabelName.setVisible(false);
            return 0;
        }
    }
    
    
    
/***********************************************************************************
 * Function: checkContentsAreStrings()
 * Description: Checks whether the content in the field contains only letters.
     * @param contentStrings - Checks whether content are strings.
     * @param jLabelName - Name of label that displays error message.
 * @return number of errors: 0 if no error is present, null if error is present.
***********************************************************************************/  
    
    public Integer checkContentsAreStrings(boolean contentStrings, javax.swing.JLabel jLabelName)
    {
        if (contentStrings == false){
            jLabelName.setVisible(true);
            return null;
        }
        else {
            jLabelName.setVisible(false);
            return 0;
        }    
    }
     
    
    
/***********************************************************************************
 * Function: checkContentsAreNumbers()
 * Description: Checks whether the content in the field contains only letters.
     * @param contentNumbers - Checks whether content are only numbers.
     * @param jLabelName - Name of label that displays error message.
 * @return number of errors: 0 if no error is present, null if error is present.
***********************************************************************************/
    
    public Integer checkContentsAreNumbers(boolean contentNumbers, javax.swing.JLabel jLabelName)
    {
        if (contentNumbers == false){
            jLabelName.setVisible(true);
            return null;
        }
        else {
            jLabelName.setVisible(false);
            return 0;
        }     
        
    }
    
    

/***********************************************************************************
 * Function: checkContentsAreLetters()
 * Description: Checks whether the content in the field contains only letters.
     * @param usernameTotalCharacters - Checks range of username.
     * @param jLabelName - Name of label that displays error message.
 * @return number of errors: 0 if no error is present, null if error is present.
***********************************************************************************/   
    
    public Integer checkUsernameCharacterRange(long usernameTotalCharacters, javax.swing.JLabel jLabelName)
    {
        if (usernameTotalCharacters < 6 || usernameTotalCharacters > 15) {
            jLabelName.setVisible(true);
            return null;
        }
        else {
            jLabelName.setVisible(false);
            return 0;
        }
    }
    
    
    
/***********************************************************************************
 * Function: checkContactCharacterRange()
 * Description: Checks whether the content in the field contains only letters.
     * @param contactNum - Checks range of contact number/s.
     * @param jLabelName - Name of label that displays error message.
 * @return number of errors: 0 if no error is present, null if error is present.
***********************************************************************************/
    
    public Integer checkContactCharacterRange(String contactNum, javax.swing.JLabel jLabelName)
    {
        int length = String.valueOf(contactNum).length();
        if (length!=7) {
            jLabelName.setVisible(true);
            return null;
        }
        else {
            jLabelName.setVisible(false);
            return 0;
        }
    }
  
    
    
/***********************************************************************************
 * Function: checkPasswordCharacterRange()
 * Description: Checks whether the content in the field contains only letters.
     * @param password - Checks range of password.
     * @param jLabelName - Name of label that displays error message.
 * @return number of errors: 0 if no error is present, null if error is present.
***********************************************************************************/
        
    public Integer checkPasswordCharacterRange(String password, javax.swing.JLabel jLabelName)
    {
        int length = String.valueOf(password).length();
        //System.out.println("Length of password is: " + length);
        
        if (length<10 || length>20) {
            jLabelName.setVisible(true);
            return null;
        }
        else {
            jLabelName.setVisible(false);
            return 0;
        }
    } 
    
    
    
/***********************************************************************************
 * Function: checkPasswordsMatch()
 * Description: Checks whether the content in the field contains only letters.
     * @param firstPassword - The first password entered.
     * @param secondPassword - The second password entered for confirmation.
     * @param jLabelName - Name of label that displays error message.
 * @return number of errors: 0 if no error is present, null if error is present.
***********************************************************************************/
           
    public Integer checkPasswordsMatch(String firstPassword, String secondPassword, javax.swing.JLabel jLabelName)
    {
        if (firstPassword == null || secondPassword == null){
            return null;
        }
        else if (!firstPassword.equals(secondPassword)){
            jLabelName.setText("Passwords does not match");
            return null;
        }
        else {
            jLabelName.setVisible(false);
            return 0;
        }
    }
}
